commit fd686abeea14ce34fadd9a0b202471c15e93d354
Merge: 27e85f4c48b 8eaaf030e48
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Feb 5 20:18:23 2024 +0530

    Merge pull request #5205 from VarunNagaraju/PS-9067
    
    PS-9067 Fix MTR test failures when run with --mem

commit c4e69e69869ab72e8d485d86fe2d60cecc82ea42
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Feb 5 15:57:30 2024 +0530

    PS-9096 Running too much data through MD5() causes server stop
    
    https://perconadev.atlassian.net/browse/PS-9096
    
    Bug#35764496 mysql/mysql-server@fc8b390e7bf
    
    The parameter type to the helper functions was int and was truncating
    the value passed.
    Fixed by making sure the length parameter is consistent.

diff --git a/include/my_md5.h b/include/my_md5.h
index c58385a715d..5a712d91de0 100644
--- a/include/my_md5.h
+++ b/include/my_md5.h
@@ -33,7 +33,7 @@
 extern "C" {
 #endif
 
-void compute_md5_hash(char *digest, const char *buf, int len);
+void compute_md5_hash(char *digest, const char *buf, size_t len);
 
 /*
   Convert an array of bytes to a hexadecimal representation.
diff --git a/mysys_ssl/my_md5.cc b/mysys_ssl/my_md5.cc
index a343468b499..9906169e083 100644
--- a/mysys_ssl/my_md5.cc
+++ b/mysys_ssl/my_md5.cc
@@ -39,7 +39,7 @@
 #if defined(HAVE_OPENSSL)
 #include <openssl/md5.h>
 
-static void my_md5_hash(unsigned char* digest, unsigned const char *buf, int len)
+static void my_md5_hash(unsigned char* digest, unsigned const char *buf, size_t len)
 {
   MD5_CTX ctx;
   MD5_Init (&ctx);
@@ -58,7 +58,7 @@ static void my_md5_hash(unsigned char* digest, unsigned const char *buf, int len
 
     @return              void
 */
-void compute_md5_hash(char *digest, const char *buf, int len)
+void compute_md5_hash(char *digest, const char *buf, size_t len)
 {
 #if defined(HAVE_OPENSSL)
   my_md5_hash((unsigned char*)digest, (unsigned const char*)buf, len);

